/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of DBus.xs. Do not edit this file, edit DBus.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "DBus.xs"
/* -*- c -*-
 *
 * Copyright (C) 2004-2006 Daniel P. Berrange
 *
 * This program is free software; You can redistribute it and/or modify
 * it under the same terms as Perl itself. Either:
 *
 * a) the GNU General Public License as published by the Free
 *   Software Foundation; either version 2, or (at your option) any
 *   later version,
 *
 * or
 *
 * b) the "Artistic License"
 *
 * The file "COPYING" distributed along with this file provides full
 * details of the terms and conditions of the two licenses.
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <dbus/dbus.h>

#if NET_DBUS_DEBUG
static int net_dbus_debug = 0;
#define DEBUG_MSG(...) if (net_dbus_debug) fprintf(stderr, __VA_ARGS__)
#else
#define DEBUG_MSG(...)
#endif


/*
 * On 32-bit OS (and some 64-bit) Perl does not have an
 * integer type capable of storing 64 bit numbers. So
 * we serialize to/from strings on these platforms
 */

dbus_int64_t
_dbus_parse_int64(SV *sv) {
#ifdef USE_64_BIT_ALL
    return SvIV(sv);
#else
    //DEBUG_MSG("Parrse %s\n", SvPV_nolen(sv));
    return strtoll(SvPV_nolen(sv), NULL, 10);
#endif
}

dbus_uint64_t
_dbus_parse_uint64(SV *sv) {
#ifdef USE_64_BIT_ALL
    return SvUV(sv);
#else
    //DEBUG_MSG("Parrse %s\n", SvPV_nolen(sv));
    return strtoull(SvPV_nolen(sv), NULL, 10);
#endif
}


#ifndef PRId64
#define PRId64 "lld"
#endif

SV *
_dbus_format_int64(dbus_int64_t val) {
#ifdef USE_64_BIT_ALL
    return newSViv(val);
#else
    char buf[100];
    int len;
    len = snprintf(buf, 100, "%" PRId64, val);
    //DEBUG_MSG("Format i64 [%" PRId64 "] to [%s]\n", val, buf);
    return newSVpv(buf, len);
#endif
}

#ifndef PRIu64
#define PRIu64 "llu"
#endif

SV *
_dbus_format_uint64(dbus_uint64_t val) {
#ifdef USE_64_BIT_ALL
    return newSVuv(val);
#else
    char buf[100];
    int len;
    len = snprintf(buf, 100, "%" PRIu64, val);
    //DEBUG_MSG("Format u64 [%" PRIu64 "] to [%s]\n", val, buf);
    return newSVpv(buf, len);
#endif
}



/* The -1 is required by the contract for
   dbus_{server,connection}_allocate_slot
   initialization */
dbus_int32_t connection_data_slot = -1;
dbus_int32_t server_data_slot = -1;
dbus_int32_t pending_call_data_slot = -1;

void
_object_release(void *obj) {
    DEBUG_MSG("Releasing object count on %p\n", obj);
    SvREFCNT_dec((SV*)obj);
}

dbus_bool_t
_watch_generic(DBusWatch *watch, void *data, char *key, dbus_bool_t server) {
    SV *selfref;
    HV *self;
    SV **call;
    SV *h_sv;
    dSP;

    DEBUG_MSG("Watch generic callback %p %p %s %d\n", watch, data, key, server);

    if (server) {
      selfref = (SV*)dbus_server_get_data((DBusServer*)data, server_data_slot);
    } else {
      selfref = (SV*)dbus_connection_get_data((DBusConnection*)data, connection_data_slot);
    }
    self = (HV*)SvRV(selfref);

    DEBUG_MSG("Got owner %p\n", self);

    call = hv_fetch(self, key, strlen(key), 0);

    if (!call) {
      warn("Could not find watch callback %s for fd %d\n",
	   key, dbus_watch_get_fd(watch));
      return FALSE;
    }

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(selfref);
    h_sv = sv_newmortal();
    sv_setref_pv(h_sv, "Net::DBus::Binding::C::Watch", (void*)watch);
    XPUSHs(h_sv);
    PUTBACK;

    call_sv(*call, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 1;
}

dbus_bool_t
_watch_server_add(DBusWatch *watch, void *data) {
    return _watch_generic(watch, data, "add_watch", 1);
}
void
_watch_server_remove(DBusWatch *watch, void *data) {
    _watch_generic(watch, data, "remove_watch", 1);
}
void
_watch_server_toggled(DBusWatch *watch, void *data) {
    _watch_generic(watch, data, "toggled_watch", 1);
}

dbus_bool_t
_watch_connection_add(DBusWatch *watch, void *data) {
    return _watch_generic(watch, data, "add_watch", 0);
}
void
_watch_connection_remove(DBusWatch *watch, void *data) {
    _watch_generic(watch, data, "remove_watch", 0);
}
void
_watch_connection_toggled(DBusWatch *watch, void *data) {
    _watch_generic(watch, data, "toggled_watch", 0);
}


dbus_bool_t
_timeout_generic(DBusTimeout *timeout, void *data, char *key, dbus_bool_t server) {
    SV *selfref;
    HV *self;
    SV **call;
    SV *h_sv;
    dSP;

    if (server) {
      selfref = (SV*)dbus_server_get_data((DBusServer*)data, server_data_slot);
    } else {
      selfref = (SV*)dbus_connection_get_data((DBusConnection*)data, connection_data_slot);
    }
    self = (HV*)SvRV(selfref);

    call = hv_fetch(self, key, strlen(key), 0);

    if (!call) {
      warn("Could not find timeout callback for %s\n", key);
      return FALSE;
    }

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs((SV*)selfref);
    h_sv = sv_newmortal();
    sv_setref_pv(h_sv, "Net::DBus::Binding::C::Timeout", (void*)timeout);
    XPUSHs(h_sv);
    PUTBACK;

    call_sv(*call, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 1;
}

dbus_bool_t
_timeout_server_add(DBusTimeout *timeout, void *data) {
    return _timeout_generic(timeout, data, "add_timeout", 1);
}
void
_timeout_server_remove(DBusTimeout *timeout, void *data) {
    _timeout_generic(timeout, data, "remove_timeout", 1);
}
void
_timeout_server_toggled(DBusTimeout *timeout, void *data) {
    _timeout_generic(timeout, data, "toggled_timeout", 1);
}

dbus_bool_t
_timeout_connection_add(DBusTimeout *timeout, void *data) {
    return _timeout_generic(timeout, data, "add_timeout", 0);
}
void
_timeout_connection_remove(DBusTimeout *timeout, void *data) {
    _timeout_generic(timeout, data, "remove_timeout", 0);
}
void
_timeout_connection_toggled(DBusTimeout *timeout, void *data) {
    _timeout_generic(timeout, data, "toggled_timeout", 0);
}

void
_connection_callback (DBusServer *server,
		      DBusConnection *new_connection,
		      void *data) {
    SV *selfref = (SV*)dbus_server_get_data((DBusServer*)data, server_data_slot);
    HV *self = (HV*)SvRV(selfref);
    SV **call;
    SV *value;
    dSP;

    call = hv_fetch(self, "_callback", strlen("_callback"), 0);

    if (!call) {
      warn("Could not find new connection callback\n");
      return;
    }

    DEBUG_MSG("Created connection in callback %p\n", new_connection);
    /* The DESTROY method will de-ref it later */
    dbus_connection_ref(new_connection);

    value = sv_newmortal();
    sv_setref_pv(value, "Net::DBus::Binding::C::Connection", (void*)new_connection);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(selfref);
    XPUSHs(value);
    PUTBACK;

    call_sv(*call, G_DISCARD);

    FREETMPS;
    LEAVE;
}


DBusHandlerResult
_message_filter(DBusConnection *con,
		DBusMessage *msg,
		void *data) {
    SV *selfref;
    HV *self;
    SV *value;
    int count;
    int handled = 0;
    dSP;

    selfref = (SV*)dbus_connection_get_data(con, connection_data_slot);
    self = (HV*)SvRV(selfref);

    DEBUG_MSG("Create message in filter %p\n", msg);
    DEBUG_MSG("  Type %d\n", dbus_message_get_type(msg));
    DEBUG_MSG("  Interface %s\n", dbus_message_get_interface(msg) ? dbus_message_get_interface(msg) : "");
    DEBUG_MSG("  Path %s\n", dbus_message_get_path(msg) ? dbus_message_get_path(msg) : "");
    DEBUG_MSG("  Member %s\n", dbus_message_get_member(msg) ? dbus_message_get_member(msg) : "");
    /* Will be de-refed in the DESTROY method */
    dbus_message_ref(msg);
    value = sv_newmortal();
    sv_setref_pv(value, "Net::DBus::Binding::C::Message", (void*)msg);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs((SV*)selfref);
    XPUSHs(value);
    XPUSHs(data);
    PUTBACK;

    count = call_method("_message_filter", G_SCALAR);
    SPAGAIN;
    if (count == 1) {
      handled = POPi;
    } else {
      handled = 0;
    }
    PUTBACK;
    DEBUG_MSG("Handled %d %d\n", count, handled);
    FREETMPS;
    LEAVE;

    return handled ? DBUS_HANDLER_RESULT_HANDLED : DBUS_HANDLER_RESULT_NOT_YET_HANDLED;
}

void
_pending_call_callback(DBusPendingCall *call,
		       void *data) {
    SV *selfref;
    HV *self;
    dSP;

    DEBUG_MSG("In pending call callback %p\n", call);
    selfref = (SV*)dbus_pending_call_get_data(call, pending_call_data_slot);
    self = (HV*)SvRV(selfref);

    dbus_pending_call_ref(call);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs((SV*)selfref);
    PUTBACK;

    call_sv(data, G_DISCARD);

    FREETMPS;
    LEAVE;
}

void
_filter_release(void *data) {
    SvREFCNT_dec(data);
}

void
_pending_call_notify_release(void *data) {
    SvREFCNT_dec(data);
}

void
_path_unregister_callback(DBusConnection *con,
			  void *data) {
    SvREFCNT_dec(data);
}

DBusHandlerResult
_path_message_callback(DBusConnection *con,
		       DBusMessage *msg,
		       void *data) {
    SV *self = (SV*)dbus_connection_get_data(con, connection_data_slot);
    SV *value;
    dSP;

    DEBUG_MSG("Got message in callback %p\n", msg);
    DEBUG_MSG("  Type %d\n", dbus_message_get_type(msg));
    DEBUG_MSG("  Interface %s\n", dbus_message_get_interface(msg) ? dbus_message_get_interface(msg) : "");
    DEBUG_MSG("  Path %s\n", dbus_message_get_path(msg) ? dbus_message_get_path(msg) : "");
    DEBUG_MSG("  Member %s\n", dbus_message_get_member(msg) ? dbus_message_get_member(msg) : "");
    /* Will be de-refed in the DESTROY method */
    dbus_message_ref(msg);
    value = sv_newmortal();
    sv_setref_pv(value, "Net::DBus::Binding::C::Message", (void*)msg);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(self);
    XPUSHs(value);
    PUTBACK;

    call_sv((SV*)data, G_DISCARD);

    FREETMPS;
    LEAVE;

    return DBUS_HANDLER_RESULT_HANDLED;
}

DBusObjectPathVTable _path_callback_vtable = {
	_path_unregister_callback,
	_path_message_callback,
	NULL,
	NULL,
	NULL,
	NULL
};

SV *
_sv_from_error (DBusError *error)
{
    HV *hv;

    if (!error) {
      warn ("error is NULL");
      return &PL_sv_undef;
    }

    if (!dbus_error_is_set (error)) {
      warn ("error is unset");
      return &PL_sv_undef;
    }

    hv = newHV ();

    /* map DBusError attributes to hash keys */
    hv_store (hv, "name", 4, newSVpv (error->name, 0), 0);
    hv_store (hv, "message", 7, newSVpv (error->message, 0), 0);

    return sv_bless (newRV_noinc ((SV*) hv), gv_stashpv ("Net::DBus::Error", TRUE));
}

void
_croak_error (DBusError *error)
{
    sv_setsv (ERRSV, _sv_from_error (error));

    /* croak does not return, so we free this now to avoid leaking */
    dbus_error_free (error);

    croak (Nullch);
}

void
_populate_constant(HV *href, char *name, int val)
{
    hv_store(href, name, strlen(name), newSViv(val), 0);
}

#define REGISTER_CONSTANT(name, key) _populate_constant(constants, #key, name)

#line 473 "DBus.c"

XS(XS_Net__DBus__Binding__Connection__open); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Connection__open)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Connection::_open(address)");
    {
	char *	address = (char *)SvPV_nolen(ST(0));
#line 525 "DBus.xs"
	DBusError error;
	DBusConnection *con;
#line 486 "DBus.c"
	DBusConnection *	RETVAL;
#line 528 "DBus.xs"
	dbus_error_init(&error);
        DEBUG_MSG("Open connection shared %s\n", address);
	con = dbus_connection_open(address, &error);
	if (!con) {
	  _croak_error (&error);
	}
        dbus_connection_ref(con);
	RETVAL = con;
#line 497 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Connection", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Connection__open_private); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Connection__open_private)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Connection::_open_private(address)");
    {
	char *	address = (char *)SvPV_nolen(ST(0));
#line 543 "DBus.xs"
	DBusError error;
	DBusConnection *con;
#line 517 "DBus.c"
	DBusConnection *	RETVAL;
#line 546 "DBus.xs"
	dbus_error_init(&error);
        DEBUG_MSG("Open connection private %s\n", address);
	con = dbus_connection_open_private(address, &error);
	if (!con) {
	  _croak_error (&error);
	}
        dbus_connection_ref(con);
	RETVAL = con;
#line 528 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Connection", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Connection__set_owner); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection__set_owner)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::_set_owner(con, owner)");
    {
	DBusConnection *	con;
	SV *	owner = ST(1);

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_set_owner() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 564 "DBus.xs"
	SvREFCNT_inc(owner);
	dbus_connection_set_data(con, connection_data_slot, owner, _object_release);
#line 556 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_disconnect); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_disconnect)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::dbus_connection_disconnect(con)");
    {
	DBusConnection *	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_disconnect() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 571 "DBus.xs"
	DEBUG_MSG("Closing connection %p\n", con);
#if HAVE_CONN_DISCONNECT
	dbus_connection_disconnect(con);
#else
	dbus_connection_close(con);
#endif
#line 584 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_ref); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_ref)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::dbus_connection_ref(con)");
    {
	DBusConnection *	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_ref() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	dbus_connection_ref(con);
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_unref); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_unref)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::dbus_connection_unref(con)");
    {
	DBusConnection *	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_unref() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	dbus_connection_unref(con);
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_get_is_connected); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_get_is_connected)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::dbus_connection_get_is_connected(con)");
    {
	DBusConnection *	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_get_is_connected() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_connection_get_is_connected(con);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_get_is_authenticated); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_get_is_authenticated)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::dbus_connection_get_is_authenticated(con)");
    {
	DBusConnection *	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_get_is_authenticated() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_connection_get_is_authenticated(con);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_flush); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_flush)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::dbus_connection_flush(con)");
    {
	DBusConnection *	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_flush() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	dbus_connection_flush(con);
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Connection__send); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection__send)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::_send(con, msg)");
    {
	DBusConnection *	con;
	DBusMessage *	msg;
#line 603 "DBus.xs"
	dbus_uint32_t serial;
#line 717 "DBus.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_send() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_send() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 605 "DBus.xs"
	if (!dbus_connection_send(con, msg, &serial)) {
	  croak("not enough memory to send message");
	}
	RETVAL = serial;
#line 739 "DBus.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Connection__send_with_reply_and_block); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection__send_with_reply_and_block)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::_send_with_reply_and_block(con, msg, timeout)");
    {
	DBusConnection *	con;
	DBusMessage *	msg;
	int	timeout = (int)SvIV(ST(2));
#line 618 "DBus.xs"
	DBusMessage *reply;
	DBusError error;
#line 759 "DBus.c"
	DBusMessage *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_send_with_reply_and_block() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_send_with_reply_and_block() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 621 "DBus.xs"
	dbus_error_init(&error);
	if (!(reply = dbus_connection_send_with_reply_and_block(con, msg, timeout, &error))) {
	  _croak_error(&error);
	}
	DEBUG_MSG("Create msg reply %p\n", reply);
	DEBUG_MSG("  Type %d\n", dbus_message_get_type(reply));
	DEBUG_MSG("  Interface %s\n", dbus_message_get_interface(reply) ? dbus_message_get_interface(reply) : "");
	DEBUG_MSG("  Path %s\n", dbus_message_get_path(reply) ? dbus_message_get_path(reply) : "");
	DEBUG_MSG("  Member %s\n", dbus_message_get_member(reply) ? dbus_message_get_member(reply) : "");
	RETVAL = reply;
#line 786 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Connection__send_with_reply); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection__send_with_reply)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::_send_with_reply(con, msg, timeout)");
    {
	DBusConnection *	con;
	DBusMessage *	msg;
	int	timeout = (int)SvIV(ST(2));
#line 641 "DBus.xs"
	DBusPendingCall *reply;
#line 808 "DBus.c"
	DBusPendingCall *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_send_with_reply() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_send_with_reply() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 643 "DBus.xs"
	if (!dbus_connection_send_with_reply(con, msg, &reply, timeout)) {
	  croak("not enough memory to send message");
	}
	DEBUG_MSG("Create pending call %p\n", reply);
	RETVAL = reply;
#line 830 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::PendingCall", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_borrow_message); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_borrow_message)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::dbus_connection_borrow_message(con)");
    {
	DBusConnection *	con;
	DBusMessage *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_borrow_message() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_connection_borrow_message(con);
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_return_message); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_return_message)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::dbus_connection_return_message(con, msg)");
    {
	DBusConnection *	con;
	DBusMessage *	msg;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_return_message() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_return_message() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	dbus_connection_return_message(con, msg);
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_steal_borrowed_message); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_steal_borrowed_message)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::dbus_connection_steal_borrowed_message(con, msg)");
    {
	DBusConnection *	con;
	DBusMessage *	msg;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_steal_borrowed_message() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_steal_borrowed_message() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	dbus_connection_steal_borrowed_message(con, msg);
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_pop_message); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection_dbus_connection_pop_message)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::dbus_connection_pop_message(con)");
    {
	DBusConnection *	con;
	DBusMessage *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_connection_pop_message() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_connection_pop_message(con);
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Connection__dispatch); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection__dispatch)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::_dispatch(con)");
    {
	DBusConnection *	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_dispatch() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 673 "DBus.xs"
	DEBUG_MSG("IN dispatch\n");
	while(dbus_connection_dispatch(con) == DBUS_DISPATCH_DATA_REMAINS);
	DEBUG_MSG("Completed \n");
#line 972 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Connection__set_watch_callbacks); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection__set_watch_callbacks)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::_set_watch_callbacks(con)");
    {
	DBusConnection *	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_set_watch_callbacks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 681 "DBus.xs"
	if (!dbus_connection_set_watch_functions(con,
						 _watch_connection_add,
						 _watch_connection_remove,
						 _watch_connection_toggled,
						 con, NULL)) {
	  croak("not enough memory to set watch functions on connection");
	}
#line 1001 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Connection__set_timeout_callbacks); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection__set_timeout_callbacks)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::_set_timeout_callbacks(con)");
    {
	DBusConnection *	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_set_timeout_callbacks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 693 "DBus.xs"
	if (!dbus_connection_set_timeout_functions(con,
						   _timeout_connection_add,
						   _timeout_connection_remove,
						   _timeout_connection_toggled,
						   con, NULL)) {
	  croak("not enough memory to set timeout functions on connection");
	}
#line 1030 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Connection__register_object_path); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection__register_object_path)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::_register_object_path(con, path, code)");
    {
	DBusConnection *	con;
	char *	path = (char *)SvPV_nolen(ST(1));
	SV *	code = ST(2);

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_register_object_path() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 707 "DBus.xs"
	SvREFCNT_inc(code);
	if (!(dbus_connection_register_object_path(con, path, &_path_callback_vtable, code))) {
	  croak("failure when registering object path");
	}
#line 1058 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Connection__unregister_object_path); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection__unregister_object_path)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::_unregister_object_path(con, path)");
    {
	DBusConnection *	con;
	char *	path = (char *)SvPV_nolen(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_unregister_object_path() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 717 "DBus.xs"
	/* The associated data will be free'd by the previously
	   registered callback */
	if (!(dbus_connection_unregister_object_path(con, path))) {
	  croak("failure when unregistering object path");
	}
#line 1086 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Connection__register_fallback); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection__register_fallback)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::_register_fallback(con, path, code)");
    {
	DBusConnection *	con;
	char *	path = (char *)SvPV_nolen(ST(1));
	SV *	code = ST(2);

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_register_fallback() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 729 "DBus.xs"
	SvREFCNT_inc(code);
	if (!(dbus_connection_register_fallback(con, path, &_path_callback_vtable, code))) {
	  croak("failure when registering fallback object path");
	}
#line 1114 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Connection__add_filter); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection__add_filter)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::_add_filter(con, code)");
    {
	DBusConnection *	con;
	SV *	code = ST(1);

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::_add_filter() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 740 "DBus.xs"
	SvREFCNT_inc(code);
	DEBUG_MSG("Adding filter %p\n", code);
	dbus_connection_add_filter(con, _message_filter, code, _filter_release);
#line 1140 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Connection_dbus_bus_register); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection_dbus_bus_register)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::dbus_bus_register(con)");
    {
	DBusConnection *	con;
#line 748 "DBus.xs"
	DBusError error;
	int reply;
#line 1157 "DBus.c"
	dbus_bool_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_bus_register() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 751 "DBus.xs"
	dbus_error_init(&error);
	if (!(reply = dbus_bus_register(con, &error))) {
	  _croak_error(&error);
	}
	RETVAL = reply;
#line 1172 "DBus.c"
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Connection_dbus_bus_add_match); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection_dbus_bus_add_match)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::dbus_bus_add_match(con, rule)");
    {
	DBusConnection *	con;
	char *	rule = (char *)SvPV_nolen(ST(1));
#line 762 "DBus.xs"
	DBusError error;
#line 1189 "DBus.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_bus_add_match() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 764 "DBus.xs"
	dbus_error_init(&error);
	DEBUG_MSG("Adding match %s\n", rule);
	dbus_bus_add_match(con, rule, &error);
	if (dbus_error_is_set(&error)) {
	  _croak_error(&error);
	}
#line 1204 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Connection_dbus_bus_remove_match); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection_dbus_bus_remove_match)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::dbus_bus_remove_match(con, rule)");
    {
	DBusConnection *	con;
	char *	rule = (char *)SvPV_nolen(ST(1));
#line 776 "DBus.xs"
	DBusError error;
#line 1221 "DBus.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_bus_remove_match() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 778 "DBus.xs"
	dbus_error_init(&error);
	DEBUG_MSG("Removeing match %s\n", rule);
	dbus_bus_remove_match(con, rule, &error);
	if (dbus_error_is_set(&error)) {
	  _croak_error(&error);
	}
#line 1236 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Connection_dbus_bus_get_unique_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection_dbus_bus_get_unique_name)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::dbus_bus_get_unique_name(con)");
    {
	DBusConnection *	con;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_bus_get_unique_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_bus_get_unique_name(con);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Connection_dbus_bus_request_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection_dbus_bus_request_name)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::dbus_bus_request_name(con, service_name)");
    {
	DBusConnection *	con;
	char *	service_name = (char *)SvPV_nolen(ST(1));
#line 794 "DBus.xs"
	DBusError error;
	int reply;
#line 1279 "DBus.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::dbus_bus_request_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 797 "DBus.xs"
	dbus_error_init(&error);
	if (!(reply = dbus_bus_request_name(con, service_name, 0, &error))) {
	  _croak_error(&error);
	}
	RETVAL = reply;
#line 1295 "DBus.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Connection_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Connection_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Connection::DESTROY(con)");
    {
	DBusConnection *	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = (DBusConnection *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Connection::DESTROY() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 809 "DBus.xs"
	DEBUG_MSG("Unrefing connection %p\n", con);
	dbus_connection_unref(con);
#line 1320 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Server__open); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Server__open)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Server::_open(address)");
    {
	char *	address = (char *)SvPV_nolen(ST(0));
#line 821 "DBus.xs"
	DBusError error;
	DBusServer *server;
#line 1337 "DBus.c"
	DBusServer *	RETVAL;
#line 824 "DBus.xs"
	dbus_error_init(&error);
	server = dbus_server_listen(address, &error);
	DEBUG_MSG("Created server %p on address %s\n", server, address);
	if (!server) {
	  _croak_error(&error);
	}
	if (!dbus_server_set_auth_mechanisms(server, NULL)) {
	    croak("not enough memory to server auth mechanisms");
	}
	RETVAL = server;
#line 1350 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Server", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Server__set_owner); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Server__set_owner)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Server::_set_owner(server, owner)");
    {
	DBusServer *	server;
	SV *	owner = ST(1);

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        server = (DBusServer *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Server::_set_owner() -- server is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 845 "DBus.xs"
	SvREFCNT_inc(owner);
	dbus_server_set_data(server, server_data_slot, owner, _object_release);
#line 1378 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Server_dbus_server_disconnect); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Server_dbus_server_disconnect)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Server::dbus_server_disconnect(server)");
    {
	DBusServer *	server;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        server = (DBusServer *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Server::dbus_server_disconnect() -- server is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	dbus_server_disconnect(server);
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Server_dbus_server_get_is_connected); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Server_dbus_server_get_is_connected)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Server::dbus_server_get_is_connected(server)");
    {
	DBusServer *	server;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        server = (DBusServer *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Server::dbus_server_get_is_connected() -- server is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_server_get_is_connected(server);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Server__set_watch_callbacks); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Server__set_watch_callbacks)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Server::_set_watch_callbacks(server)");
    {
	DBusServer *	server;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        server = (DBusServer *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Server::_set_watch_callbacks() -- server is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 860 "DBus.xs"
	if (!dbus_server_set_watch_functions(server,
					     _watch_server_add,
					     _watch_server_remove,
					     _watch_server_toggled,
					     server, NULL)) {
	  croak("not enough memory to set watch functions on server");
	}
#line 1454 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Server__set_timeout_callbacks); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Server__set_timeout_callbacks)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Server::_set_timeout_callbacks(server)");
    {
	DBusServer *	server;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        server = (DBusServer *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Server::_set_timeout_callbacks() -- server is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 873 "DBus.xs"
	if (!dbus_server_set_timeout_functions(server,
					       _timeout_server_add,
					       _timeout_server_remove,
					       _timeout_server_toggled,
					       server, NULL)) {
	  croak("not enough memory to set timeout functions on server");
	}
#line 1483 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Server__set_connection_callback); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Server__set_connection_callback)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Server::_set_connection_callback(server)");
    {
	DBusServer *	server;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        server = (DBusServer *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Server::_set_connection_callback() -- server is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 886 "DBus.xs"
	dbus_server_set_new_connection_function(server,
						_connection_callback,
						server, NULL);
#line 1508 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Server_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Server_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Server::DESTROY(server)");
    {
	DBusServer *	server;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        server = (DBusServer *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Server::DESTROY() -- server is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 894 "DBus.xs"
	DEBUG_MSG("Destroying server %p\n", server);
	dbus_server_unref(server);
#line 1532 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Bus__open); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Bus__open)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Bus::_open(type)");
    {
	DBusBusType	type = (DBusBusType)SvIV(ST(0));
#line 906 "DBus.xs"
	DBusError error;
	DBusConnection *con;
#line 1549 "DBus.c"
	DBusConnection *	RETVAL;
#line 909 "DBus.xs"
	dbus_error_init(&error);
        DEBUG_MSG("Open bus shared %d\n", type);
	con = dbus_bus_get(type, &error);
	if (!con) {
	  _croak_error(&error);
	}
        dbus_connection_ref(con);
	RETVAL = con;
#line 1560 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Connection", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Bus__open_private); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Bus__open_private)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Bus::_open_private(type)");
    {
	DBusBusType	type = (DBusBusType)SvIV(ST(0));
#line 924 "DBus.xs"
	DBusError error;
	DBusConnection *con;
#line 1580 "DBus.c"
	DBusConnection *	RETVAL;
#line 927 "DBus.xs"
	dbus_error_init(&error);
        DEBUG_MSG("Open bus private %d\n", type);
	con = dbus_bus_get_private(type, &error);
	if (!con) {
	  _croak_error(&error);
	}
        dbus_connection_ref(con);
	RETVAL = con;
#line 1591 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Connection", (void*)RETVAL );

    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Message__create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Message__create)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Message::_create(type)");
    {
	IV	type = (IV)SvIV(ST(0));
#line 946 "DBus.xs"
	DBusMessage *msg;
#line 1610 "DBus.c"
	DBusMessage *	RETVAL;
#line 948 "DBus.xs"
	msg = dbus_message_new(type);
	if (!msg) {
	  croak("No memory to allocate message");
	}
	DEBUG_MSG("Create msg new %p\n", msg);
	DEBUG_MSG("  Type %d\n", dbus_message_get_type(msg));
	RETVAL = msg;
#line 1620 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Message__iterator_append); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Message__iterator_append)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Message::_iterator_append(msg)");
    {
	DBusMessage *	msg;
	DBusMessageIter *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Message::_iterator_append() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 963 "DBus.xs"
	RETVAL = dbus_new(DBusMessageIter, 1);
	dbus_message_iter_init_append(msg, RETVAL);
#line 1649 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::Iterator", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Message__iterator); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Message__iterator)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Message::_iterator(msg)");
    {
	DBusMessage *	msg;
	DBusMessageIter *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Message::_iterator() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 973 "DBus.xs"
	RETVAL = dbus_new(DBusMessageIter, 1);
	dbus_message_iter_init(msg, RETVAL);
#line 1676 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::Iterator", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Message_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Message_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Message::DESTROY(msg)");
    {
	DBusMessage *	msg;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::DESTROY() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 985 "DBus.xs"
	DEBUG_MSG("De-referencing message %p\n", msg);
	DEBUG_MSG("  Type %d\n", dbus_message_get_type(msg));
	DEBUG_MSG("  Interface %s\n", dbus_message_get_interface(msg) ? dbus_message_get_interface(msg) : "");
	DEBUG_MSG("  Path %s\n", dbus_message_get_path(msg) ? dbus_message_get_path(msg) : "");
	DEBUG_MSG("  Member %s\n", dbus_message_get_member(msg) ? dbus_message_get_member(msg) : "");
	dbus_message_unref(msg);
#line 1706 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_no_reply); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_no_reply)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Message::dbus_message_get_no_reply(msg)");
    {
	DBusMessage *	msg;
	dbus_bool_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_no_reply() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_message_get_no_reply(msg);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Message_dbus_message_set_no_reply); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Message_dbus_message_set_no_reply)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Message::dbus_message_set_no_reply(msg, flag)");
    {
	DBusMessage *	msg;
	dbus_bool_t	flag = (bool)SvTRUE(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_set_no_reply() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	dbus_message_set_no_reply(msg, flag);
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_type)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Message::dbus_message_get_type(msg)");
    {
	DBusMessage *	msg;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_type() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_message_get_type(msg);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_interface); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_interface)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Message::dbus_message_get_interface(msg)");
    {
	DBusMessage *	msg;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_interface() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_message_get_interface(msg);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_path); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_path)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Message::dbus_message_get_path(msg)");
    {
	DBusMessage *	msg;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_path() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_message_get_path(msg);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_destination); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_destination)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Message::dbus_message_get_destination(msg)");
    {
	DBusMessage *	msg;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_destination() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_message_get_destination(msg);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_sender); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_sender)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Message::dbus_message_get_sender(msg)");
    {
	DBusMessage *	msg;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_sender() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_message_get_sender(msg);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_serial); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_serial)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Message::dbus_message_get_serial(msg)");
    {
	DBusMessage *	msg;
	dbus_uint32_t	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_serial() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_message_get_serial(msg);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_member); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_member)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Message::dbus_message_get_member(msg)");
    {
	DBusMessage *	msg;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_member() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_message_get_member(msg);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_error_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_error_name)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Message::dbus_message_get_error_name(msg)");
    {
	DBusMessage *	msg;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_error_name() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_message_get_error_name(msg);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_signature); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Message_dbus_message_get_signature)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Message::dbus_message_get_signature(msg)");
    {
	DBusMessage *	msg;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_get_signature() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_message_get_signature(msg);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Message_dbus_message_set_sender); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Message_dbus_message_set_sender)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Message::dbus_message_set_sender(msg, sender)");
    {
	DBusMessage *	msg;
	const char *	sender = (const char *)SvPV_nolen(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_set_sender() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	dbus_message_set_sender(msg, sender);
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Message_dbus_message_set_destination); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Message_dbus_message_set_destination)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Message::dbus_message_set_destination(msg, dest)");
    {
	DBusMessage *	msg;
	const char *	dest = (const char *)SvPV_nolen(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        msg = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Message::dbus_message_set_destination() -- msg is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	dbus_message_set_destination(msg, dest);
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Message__Signal__create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Message__Signal__create)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Message::Signal::_create(path, interface, name)");
    {
	char *	path = (char *)SvPV_nolen(ST(0));
	char *	interface = (char *)SvPV_nolen(ST(1));
	char *	name = (char *)SvPV_nolen(ST(2));
#line 1057 "DBus.xs"
	DBusMessage *msg;
#line 2043 "DBus.c"
	DBusMessage *	RETVAL;
#line 1059 "DBus.xs"
	msg = dbus_message_new_signal(path, interface, name);
	if (!msg) {
	  croak("No memory to allocate message");
	}
	DEBUG_MSG("Create msg new signal %p\n", msg);
	DEBUG_MSG("  Type %d\n", dbus_message_get_type(msg));
	DEBUG_MSG("  Interface %s\n", dbus_message_get_interface(msg) ? dbus_message_get_interface(msg) : "");
	DEBUG_MSG("  Path %s\n", dbus_message_get_path(msg) ? dbus_message_get_path(msg) : "");
	DEBUG_MSG("  Member %s\n", dbus_message_get_member(msg) ? dbus_message_get_member(msg) : "");
	RETVAL = msg;
#line 2056 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Message__MethodCall__create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Message__MethodCall__create)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Message::MethodCall::_create(service, path, interface, method)");
    {
	char *	service = (char *)SvPV_nolen(ST(0));
	char *	path = (char *)SvPV_nolen(ST(1));
	char *	interface = (char *)SvPV_nolen(ST(2));
	char *	method = (char *)SvPV_nolen(ST(3));
#line 1083 "DBus.xs"
	DBusMessage *msg;
#line 2079 "DBus.c"
	DBusMessage *	RETVAL;
#line 1085 "DBus.xs"
	msg = dbus_message_new_method_call(service, path, interface, method);
	if (!msg) {
	  croak("No memory to allocate message");
	}
	DEBUG_MSG("Create msg new method call %p\n", msg);
	DEBUG_MSG("  Type %d\n", dbus_message_get_type(msg));
	DEBUG_MSG("  Interface %s\n", dbus_message_get_interface(msg) ? dbus_message_get_interface(msg) : "");
	DEBUG_MSG("  Path %s\n", dbus_message_get_path(msg) ? dbus_message_get_path(msg) : "");
	DEBUG_MSG("  Member %s\n", dbus_message_get_member(msg) ? dbus_message_get_member(msg) : "");
	RETVAL = msg;
#line 2092 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Message__MethodReturn__create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Message__MethodReturn__create)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Message::MethodReturn::_create(call)");
    {
	DBusMessage *	call;
#line 1106 "DBus.xs"
	DBusMessage *msg;
#line 2112 "DBus.c"
	DBusMessage *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        call = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Message::MethodReturn::_create() -- call is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1108 "DBus.xs"
	msg = dbus_message_new_method_return(call);
	if (!msg) {
	  croak("No memory to allocate message");
	}
	dbus_message_set_interface(msg, dbus_message_get_interface(call));
	dbus_message_set_path(msg, dbus_message_get_path(call));
	dbus_message_set_member(msg, dbus_message_get_member(call));
	DEBUG_MSG("Create msg new method return %p\n", msg);
	DEBUG_MSG("  Type %d\n", dbus_message_get_type(msg));
	DEBUG_MSG("  Interface %s\n", dbus_message_get_interface(msg) ? dbus_message_get_interface(msg) : "");
	DEBUG_MSG("  Path %s\n", dbus_message_get_path(msg) ? dbus_message_get_path(msg) : "");
	DEBUG_MSG("  Member %s\n", dbus_message_get_member(msg) ? dbus_message_get_member(msg) : "");
	RETVAL = msg;
#line 2135 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Message__Error__create); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Message__Error__create)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Message::Error::_create(replyto, name, message)");
    {
	DBusMessage *	replyto;
	char *	name = (char *)SvPV_nolen(ST(1));
	char *	message = (char *)SvPV_nolen(ST(2));
#line 1134 "DBus.xs"
	DBusMessage *msg;
#line 2157 "DBus.c"
	DBusMessage *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        replyto = (DBusMessage *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Message::Error::_create() -- replyto is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1136 "DBus.xs"
	msg = dbus_message_new_error(replyto, name, message);
	if (!msg) {
	  croak("No memory to allocate message");
	}
	DEBUG_MSG("Create msg new error %p\n", msg);
	DEBUG_MSG("  Type %d\n", dbus_message_get_type(msg));
	DEBUG_MSG("  Interface %s\n", dbus_message_get_interface(msg) ? dbus_message_get_interface(msg) : "");
	DEBUG_MSG("  Path %s\n", dbus_message_get_path(msg) ? dbus_message_get_path(msg) : "");
	DEBUG_MSG("  Member %s\n", dbus_message_get_member(msg) ? dbus_message_get_member(msg) : "");
	RETVAL = msg;
#line 2177 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__PendingCall__steal_reply); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__PendingCall__steal_reply)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::PendingCall::_steal_reply(call)");
    {
	DBusPendingCall *	call;
#line 1157 "DBus.xs"
        DBusMessage *msg;
#line 2197 "DBus.c"
	DBusMessage *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        call = (DBusPendingCall *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::PendingCall::_steal_reply() -- call is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1159 "DBus.xs"
        DEBUG_MSG("Stealing pending call reply %p\n", call);
	msg = dbus_pending_call_steal_reply(call);
        dbus_message_ref(msg);
        DEBUG_MSG("Got reply message %p\n", msg);
        RETVAL = msg;
#line 2212 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::C::Message", (void*)RETVAL );


    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_block); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_block)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::PendingCall::dbus_pending_call_block(call)");
    {
	DBusPendingCall *	call;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        call = (DBusPendingCall *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::PendingCall::dbus_pending_call_block() -- call is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	dbus_pending_call_block(call);
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_get_completed); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_get_completed)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::PendingCall::dbus_pending_call_get_completed(call)");
    {
	DBusPendingCall *	call;
	dbus_bool_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        call = (DBusPendingCall *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::PendingCall::dbus_pending_call_get_completed() -- call is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	RETVAL = dbus_pending_call_get_completed(call);
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_cancel); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_cancel)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::PendingCall::dbus_pending_call_cancel(call)");
    {
	DBusPendingCall *	call;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        call = (DBusPendingCall *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::PendingCall::dbus_pending_call_cancel() -- call is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

	dbus_pending_call_cancel(call);
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__PendingCall__set_notify); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__PendingCall__set_notify)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::PendingCall::_set_notify(call, code)");
    {
	DBusPendingCall *	call;
	SV *	code = ST(1);

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        call = (DBusPendingCall *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::PendingCall::_set_notify() -- call is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1184 "DBus.xs"
	SvREFCNT_inc(code);
	DEBUG_MSG("Adding pending call notify %p\n", code);
	dbus_pending_call_set_notify(call, _pending_call_callback, code, _pending_call_notify_release);
#line 2311 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__PendingCall_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__PendingCall_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::PendingCall::DESTROY(call)");
    {
	DBusPendingCall *	call;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        call = (DBusPendingCall *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::PendingCall::DESTROY() -- call is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1192 "DBus.xs"
	DEBUG_MSG("Unrefing pending call %p", call);
	dbus_pending_call_unref(call);
#line 2335 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Watch_get_fileno); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Watch_get_fileno)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Watch::get_fileno(watch)");
    {
	DBusWatch *	watch;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        watch = (DBusWatch *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Watch::get_fileno() -- watch is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1201 "DBus.xs"
	RETVAL = dbus_watch_get_fd(watch);
#line 2360 "DBus.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Watch_get_flags); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Watch_get_flags)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Watch::get_flags(watch)");
    {
	DBusWatch *	watch;
	unsigned int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        watch = (DBusWatch *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Watch::get_flags() -- watch is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1209 "DBus.xs"
	RETVAL = dbus_watch_get_flags(watch);
#line 2386 "DBus.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Watch_is_enabled); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Watch_is_enabled)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Watch::is_enabled(watch)");
    {
	DBusWatch *	watch;
	dbus_bool_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        watch = (DBusWatch *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Watch::is_enabled() -- watch is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1217 "DBus.xs"
	RETVAL = dbus_watch_get_enabled(watch);
#line 2411 "DBus.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Watch_handle); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Watch_handle)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Watch::handle(watch, flags)");
    {
	DBusWatch *	watch;
	unsigned int	flags = (unsigned int)SvUV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        watch = (DBusWatch *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Watch::handle() -- watch is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1226 "DBus.xs"
	DEBUG_MSG("Handling event %d on fd %d (%p)\n", flags, dbus_watch_get_fd(watch), watch);
	dbus_watch_handle(watch, flags);
#line 2438 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Watch_get_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Watch_get_data)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Watch::get_data(watch)");
    {
	DBusWatch *	watch;
	void *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        watch = (DBusWatch *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Watch::get_data() -- watch is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1234 "DBus.xs"
	RETVAL = dbus_watch_get_data(watch);
#line 2463 "DBus.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Watch_set_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Watch_set_data)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Watch::set_data(watch, data)");
    {
	DBusWatch *	watch;
	void *	data = INT2PTR(void *,SvIV(ST(1)));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        watch = (DBusWatch *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Watch::set_data() -- watch is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1243 "DBus.xs"
	dbus_watch_set_data(watch, data, NULL);
#line 2488 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Timeout_get_interval); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Timeout_get_interval)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Timeout::get_interval(timeout)");
    {
	DBusTimeout *	timeout;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        timeout = (DBusTimeout *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Timeout::get_interval() -- timeout is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1252 "DBus.xs"
	RETVAL = dbus_timeout_get_interval(timeout);
#line 2513 "DBus.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Timeout_is_enabled); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Timeout_is_enabled)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Timeout::is_enabled(timeout)");
    {
	DBusTimeout *	timeout;
	dbus_bool_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        timeout = (DBusTimeout *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Timeout::is_enabled() -- timeout is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1260 "DBus.xs"
	RETVAL = dbus_timeout_get_enabled(timeout);
#line 2538 "DBus.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Timeout_handle); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Timeout_handle)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Timeout::handle(timeout)");
    {
	DBusTimeout *	timeout;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        timeout = (DBusTimeout *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Timeout::handle() -- timeout is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1268 "DBus.xs"
	DEBUG_MSG("Handling timeout event %p\n", timeout);
	dbus_timeout_handle(timeout);
#line 2564 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__C__Timeout_get_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Timeout_get_data)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Timeout::get_data(timeout)");
    {
	DBusTimeout *	timeout;
	void *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        timeout = (DBusTimeout *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Timeout::get_data() -- timeout is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1275 "DBus.xs"
	RETVAL = dbus_timeout_get_data(timeout);
#line 2589 "DBus.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__C__Timeout_set_data); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__C__Timeout_set_data)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::C::Timeout::set_data(timeout, data)");
    {
	DBusTimeout *	timeout;
	void *	data = INT2PTR(void *,SvIV(ST(1)));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        timeout = (DBusTimeout *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::C::Timeout::set_data() -- timeout is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1284 "DBus.xs"
	dbus_timeout_set_data(timeout, data, NULL);
#line 2614 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Iterator__recurse); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator__recurse)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::_recurse(iter)");
    {
	DBusMessageIter *	iter;
	DBusMessageIter *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::_recurse() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1292 "DBus.xs"
	RETVAL = dbus_new(DBusMessageIter, 1);
	dbus_message_iter_recurse(iter, RETVAL);
#line 2639 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::Iterator", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator__open_container); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator__open_container)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::_open_container(iter, type, sig)");
    {
	DBusMessageIter *	iter;
	int	type = (int)SvIV(ST(1));
	char *	sig = (char *)SvPV_nolen(ST(2));
	DBusMessageIter *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::_open_container() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1303 "DBus.xs"
	RETVAL = dbus_new(DBusMessageIter, 1);
	if (!dbus_message_iter_open_container(iter, type, sig && *sig == '\0' ? NULL : sig, RETVAL)) {
		dbus_free(RETVAL);
		croak("failed to open iterator container");
	}
#line 2671 "DBus.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Net::DBus::Binding::Iterator", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator__close_container); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator__close_container)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::_close_container(iter, sub_iter)");
    {
	DBusMessageIter *	iter;
	DBusMessageIter *	sub_iter;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::_close_container() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        sub_iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(1) ));
    else {
        warn( "Net::DBus::Binding::Iterator::_close_container() -- sub_iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1316 "DBus.xs"
	dbus_message_iter_close_container(iter, sub_iter);
#line 2704 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Iterator_get_arg_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_get_arg_type)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::get_arg_type(iter)");
    {
	DBusMessageIter *	iter;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_arg_type() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1322 "DBus.xs"
	RETVAL = dbus_message_iter_get_arg_type(iter);
#line 2729 "DBus.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator_get_element_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_get_element_type)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::get_element_type(iter)");
    {
	DBusMessageIter *	iter;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_element_type() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1330 "DBus.xs"
	RETVAL = dbus_message_iter_get_element_type(iter);
#line 2755 "DBus.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator_has_next); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_has_next)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::has_next(iter)");
    {
	DBusMessageIter *	iter;
	dbus_bool_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::has_next() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1338 "DBus.xs"
	RETVAL = dbus_message_iter_has_next(iter);
#line 2780 "DBus.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator_next); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_next)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::next(iter)");
    {
	DBusMessageIter *	iter;
	dbus_bool_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::next() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1346 "DBus.xs"
	RETVAL = dbus_message_iter_next(iter);
#line 2806 "DBus.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator_get_boolean); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_get_boolean)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::get_boolean(iter)");
    {
	DBusMessageIter *	iter;
	dbus_bool_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_boolean() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1354 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 2832 "DBus.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator_get_byte); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_get_byte)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::get_byte(iter)");
    {
	DBusMessageIter *	iter;
	unsigned char	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_byte() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1362 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 2859 "DBus.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator_get_int16); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_get_int16)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::get_int16(iter)");
    {
	DBusMessageIter *	iter;
	dbus_int16_t	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_int16() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1370 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 2885 "DBus.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator_get_uint16); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_get_uint16)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::get_uint16(iter)");
    {
	DBusMessageIter *	iter;
	dbus_uint16_t	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_uint16() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1378 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 2911 "DBus.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator_get_int32); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_get_int32)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::get_int32(iter)");
    {
	DBusMessageIter *	iter;
	dbus_int32_t	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_int32() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1386 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 2937 "DBus.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator_get_uint32); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_get_uint32)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::get_uint32(iter)");
    {
	DBusMessageIter *	iter;
	dbus_uint32_t	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_uint32() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1394 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 2963 "DBus.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator__get_int64); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator__get_int64)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::_get_int64(iter)");
    {
	DBusMessageIter *	iter;
	dbus_int64_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::_get_int64() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1402 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 2988 "DBus.c"
    ST(0) = _dbus_format_int64(RETVAL);

	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator__get_uint64); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator__get_uint64)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::_get_uint64(iter)");
    {
	DBusMessageIter *	iter;
	dbus_uint64_t	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::_get_uint64() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1410 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3015 "DBus.c"
    ST(0) = _dbus_format_uint64(RETVAL);

	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator_get_double); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_get_double)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::get_double(iter)");
    {
	DBusMessageIter *	iter;
	double	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_double() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1418 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3043 "DBus.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator_get_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_get_string)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::get_string(iter)");
    {
	DBusMessageIter *	iter;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_string() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1426 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3069 "DBus.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator_get_signature); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_get_signature)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::get_signature(iter)");
    {
	DBusMessageIter *	iter;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_signature() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1434 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3095 "DBus.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator_get_object_path); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_get_object_path)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::get_object_path(iter)");
    {
	DBusMessageIter *	iter;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::get_object_path() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1442 "DBus.xs"
	dbus_message_iter_get_basic(iter, &RETVAL);
#line 3121 "DBus.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Net__DBus__Binding__Iterator_append_boolean); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_append_boolean)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::append_boolean(iter, val)");
    {
	DBusMessageIter *	iter;
	dbus_bool_t	val = (bool)SvTRUE(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_boolean() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1452 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_BOOLEAN, &val)) {
	  croak("cannot append boolean");
	}
#line 3148 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Iterator_append_byte); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_append_byte)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::append_byte(iter, val)");
    {
	DBusMessageIter *	iter;
	unsigned char	val = (unsigned char)SvUV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_byte() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1461 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_BYTE, &val)) {
	  croak("cannot append byte");
	}
#line 3174 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Iterator_append_int16); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_append_int16)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::append_int16(iter, val)");
    {
	DBusMessageIter *	iter;
	dbus_int16_t	val = (dbus_int16_t)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_int16() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1470 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_INT16, &val)) {
	  croak("cannot append int16");
	}
#line 3200 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Iterator_append_uint16); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_append_uint16)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::append_uint16(iter, val)");
    {
	DBusMessageIter *	iter;
	dbus_uint16_t	val = (dbus_uint16_t)SvUV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_uint16() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1479 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_UINT16, &val)) {
	  croak("cannot append uint16");
	}
#line 3226 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Iterator_append_int32); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_append_int32)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::append_int32(iter, val)");
    {
	DBusMessageIter *	iter;
	dbus_int32_t	val = (dbus_int32_t)SvIV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_int32() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1488 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_INT32, &val)) {
	  croak("cannot append int32");
	}
#line 3252 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Iterator_append_uint32); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_append_uint32)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::append_uint32(iter, val)");
    {
	DBusMessageIter *	iter;
	dbus_uint32_t	val = (dbus_uint32_t)SvUV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_uint32() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1497 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_UINT32, &val)) {
	  croak("cannot append uint32");
	}
#line 3278 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Iterator__append_int64); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator__append_int64)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::_append_int64(iter, val)");
    {
	DBusMessageIter *	iter;
	dbus_int64_t    val = _dbus_parse_int64(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::_append_int64() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1506 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_INT64, &val)) {
	  croak("cannot append int64");
	}
#line 3304 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Iterator__append_uint64); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator__append_uint64)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::_append_uint64(iter, val)");
    {
	DBusMessageIter *	iter;
	dbus_uint64_t    val = _dbus_parse_uint64(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::_append_uint64() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1515 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_UINT64, &val)) {
	  croak("cannot append uint64");
	}
#line 3330 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Iterator_append_double); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_append_double)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::append_double(iter, val)");
    {
	DBusMessageIter *	iter;
	double	val = (double)SvNV(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_double() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1524 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_DOUBLE, &val)) {
	  croak("cannot append double");
	}
#line 3356 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Iterator_append_string); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_append_string)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::append_string(iter, val)");
    {
	DBusMessageIter *	iter;
	char *	val = (char *)SvPV_nolen(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_string() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1533 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_STRING, &val)) {
	  croak("cannot append string");
	}
#line 3382 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Iterator_append_object_path); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_append_object_path)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::append_object_path(iter, val)");
    {
	DBusMessageIter *	iter;
	char *	val = (char *)SvPV_nolen(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_object_path() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1542 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_OBJECT_PATH, &val)) {
	  croak("cannot append object path");
	}
#line 3408 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Iterator_append_signature); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_append_signature)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::append_signature(iter, val)");
    {
	DBusMessageIter *	iter;
	char *	val = (char *)SvPV_nolen(ST(1));

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::append_signature() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1551 "DBus.xs"
	if (!dbus_message_iter_append_basic(iter, DBUS_TYPE_SIGNATURE, &val)) {
	  croak("cannot append signature");
	}
#line 3434 "DBus.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Net__DBus__Binding__Iterator_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Net__DBus__Binding__Iterator_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Net::DBus::Binding::Iterator::DESTROY(iter)");
    {
	DBusMessageIter *	iter;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iter = (DBusMessageIter *)SvIV((SV*)SvRV( ST(0) ));
    else {
        warn( "Net::DBus::Binding::Iterator::DESTROY() -- iter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    };
#line 1561 "DBus.xs"
	DEBUG_MSG("Destroying iterator %p\n", iter);
	dbus_free(iter);
#line 3458 "DBus.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Net__DBus); /* prototype to pass -Wmissing-prototypes */
XS(boot_Net__DBus)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXSproto("Net::DBus::Binding::Connection::_open", XS_Net__DBus__Binding__Connection__open, file, "$");
        newXSproto("Net::DBus::Binding::Connection::_open_private", XS_Net__DBus__Binding__Connection__open_private, file, "$");
        newXSproto("Net::DBus::Binding::C::Connection::_set_owner", XS_Net__DBus__Binding__C__Connection__set_owner, file, "$$");
        newXSproto("Net::DBus::Binding::C::Connection::dbus_connection_disconnect", XS_Net__DBus__Binding__C__Connection_dbus_connection_disconnect, file, "$");
        newXSproto("Net::DBus::Binding::C::Connection::dbus_connection_ref", XS_Net__DBus__Binding__C__Connection_dbus_connection_ref, file, "$");
        newXSproto("Net::DBus::Binding::C::Connection::dbus_connection_unref", XS_Net__DBus__Binding__C__Connection_dbus_connection_unref, file, "$");
        newXSproto("Net::DBus::Binding::C::Connection::dbus_connection_get_is_connected", XS_Net__DBus__Binding__C__Connection_dbus_connection_get_is_connected, file, "$");
        newXSproto("Net::DBus::Binding::C::Connection::dbus_connection_get_is_authenticated", XS_Net__DBus__Binding__C__Connection_dbus_connection_get_is_authenticated, file, "$");
        newXSproto("Net::DBus::Binding::C::Connection::dbus_connection_flush", XS_Net__DBus__Binding__C__Connection_dbus_connection_flush, file, "$");
        newXSproto("Net::DBus::Binding::C::Connection::_send", XS_Net__DBus__Binding__C__Connection__send, file, "$$");
        newXSproto("Net::DBus::Binding::C::Connection::_send_with_reply_and_block", XS_Net__DBus__Binding__C__Connection__send_with_reply_and_block, file, "$$$");
        newXSproto("Net::DBus::Binding::C::Connection::_send_with_reply", XS_Net__DBus__Binding__C__Connection__send_with_reply, file, "$$$");
        newXSproto("Net::DBus::Binding::C::Connection::dbus_connection_borrow_message", XS_Net__DBus__Binding__C__Connection_dbus_connection_borrow_message, file, "$");
        newXSproto("Net::DBus::Binding::C::Connection::dbus_connection_return_message", XS_Net__DBus__Binding__C__Connection_dbus_connection_return_message, file, "$$");
        newXSproto("Net::DBus::Binding::C::Connection::dbus_connection_steal_borrowed_message", XS_Net__DBus__Binding__C__Connection_dbus_connection_steal_borrowed_message, file, "$$");
        newXSproto("Net::DBus::Binding::C::Connection::dbus_connection_pop_message", XS_Net__DBus__Binding__C__Connection_dbus_connection_pop_message, file, "$");
        newXSproto("Net::DBus::Binding::C::Connection::_dispatch", XS_Net__DBus__Binding__C__Connection__dispatch, file, "$");
        newXSproto("Net::DBus::Binding::C::Connection::_set_watch_callbacks", XS_Net__DBus__Binding__C__Connection__set_watch_callbacks, file, "$");
        newXSproto("Net::DBus::Binding::C::Connection::_set_timeout_callbacks", XS_Net__DBus__Binding__C__Connection__set_timeout_callbacks, file, "$");
        newXSproto("Net::DBus::Binding::C::Connection::_register_object_path", XS_Net__DBus__Binding__C__Connection__register_object_path, file, "$$$");
        newXSproto("Net::DBus::Binding::C::Connection::_unregister_object_path", XS_Net__DBus__Binding__C__Connection__unregister_object_path, file, "$$");
        newXSproto("Net::DBus::Binding::C::Connection::_register_fallback", XS_Net__DBus__Binding__C__Connection__register_fallback, file, "$$$");
        newXSproto("Net::DBus::Binding::C::Connection::_add_filter", XS_Net__DBus__Binding__C__Connection__add_filter, file, "$$");
        newXSproto("Net::DBus::Binding::C::Connection::dbus_bus_register", XS_Net__DBus__Binding__C__Connection_dbus_bus_register, file, "$");
        newXSproto("Net::DBus::Binding::C::Connection::dbus_bus_add_match", XS_Net__DBus__Binding__C__Connection_dbus_bus_add_match, file, "$$");
        newXSproto("Net::DBus::Binding::C::Connection::dbus_bus_remove_match", XS_Net__DBus__Binding__C__Connection_dbus_bus_remove_match, file, "$$");
        newXSproto("Net::DBus::Binding::C::Connection::dbus_bus_get_unique_name", XS_Net__DBus__Binding__C__Connection_dbus_bus_get_unique_name, file, "$");
        newXSproto("Net::DBus::Binding::C::Connection::dbus_bus_request_name", XS_Net__DBus__Binding__C__Connection_dbus_bus_request_name, file, "$$");
        newXSproto("Net::DBus::Binding::C::Connection::DESTROY", XS_Net__DBus__Binding__C__Connection_DESTROY, file, "$");
        newXSproto("Net::DBus::Binding::Server::_open", XS_Net__DBus__Binding__Server__open, file, "$");
        newXSproto("Net::DBus::Binding::C::Server::_set_owner", XS_Net__DBus__Binding__C__Server__set_owner, file, "$$");
        newXSproto("Net::DBus::Binding::C::Server::dbus_server_disconnect", XS_Net__DBus__Binding__C__Server_dbus_server_disconnect, file, "$");
        newXSproto("Net::DBus::Binding::C::Server::dbus_server_get_is_connected", XS_Net__DBus__Binding__C__Server_dbus_server_get_is_connected, file, "$");
        newXSproto("Net::DBus::Binding::C::Server::_set_watch_callbacks", XS_Net__DBus__Binding__C__Server__set_watch_callbacks, file, "$");
        newXSproto("Net::DBus::Binding::C::Server::_set_timeout_callbacks", XS_Net__DBus__Binding__C__Server__set_timeout_callbacks, file, "$");
        newXSproto("Net::DBus::Binding::C::Server::_set_connection_callback", XS_Net__DBus__Binding__C__Server__set_connection_callback, file, "$");
        newXSproto("Net::DBus::Binding::C::Server::DESTROY", XS_Net__DBus__Binding__C__Server_DESTROY, file, "$");
        newXSproto("Net::DBus::Binding::Bus::_open", XS_Net__DBus__Binding__Bus__open, file, "$");
        newXSproto("Net::DBus::Binding::Bus::_open_private", XS_Net__DBus__Binding__Bus__open_private, file, "$");
        newXSproto("Net::DBus::Binding::Message::_create", XS_Net__DBus__Binding__Message__create, file, "$");
        newXSproto("Net::DBus::Binding::Message::_iterator_append", XS_Net__DBus__Binding__Message__iterator_append, file, "$");
        newXSproto("Net::DBus::Binding::Message::_iterator", XS_Net__DBus__Binding__Message__iterator, file, "$");
        newXSproto("Net::DBus::Binding::C::Message::DESTROY", XS_Net__DBus__Binding__C__Message_DESTROY, file, "$");
        newXSproto("Net::DBus::Binding::C::Message::dbus_message_get_no_reply", XS_Net__DBus__Binding__C__Message_dbus_message_get_no_reply, file, "$");
        newXSproto("Net::DBus::Binding::C::Message::dbus_message_set_no_reply", XS_Net__DBus__Binding__C__Message_dbus_message_set_no_reply, file, "$$");
        newXSproto("Net::DBus::Binding::C::Message::dbus_message_get_type", XS_Net__DBus__Binding__C__Message_dbus_message_get_type, file, "$");
        newXSproto("Net::DBus::Binding::C::Message::dbus_message_get_interface", XS_Net__DBus__Binding__C__Message_dbus_message_get_interface, file, "$");
        newXSproto("Net::DBus::Binding::C::Message::dbus_message_get_path", XS_Net__DBus__Binding__C__Message_dbus_message_get_path, file, "$");
        newXSproto("Net::DBus::Binding::C::Message::dbus_message_get_destination", XS_Net__DBus__Binding__C__Message_dbus_message_get_destination, file, "$");
        newXSproto("Net::DBus::Binding::C::Message::dbus_message_get_sender", XS_Net__DBus__Binding__C__Message_dbus_message_get_sender, file, "$");
        newXSproto("Net::DBus::Binding::C::Message::dbus_message_get_serial", XS_Net__DBus__Binding__C__Message_dbus_message_get_serial, file, "$");
        newXSproto("Net::DBus::Binding::C::Message::dbus_message_get_member", XS_Net__DBus__Binding__C__Message_dbus_message_get_member, file, "$");
        newXSproto("Net::DBus::Binding::C::Message::dbus_message_get_error_name", XS_Net__DBus__Binding__C__Message_dbus_message_get_error_name, file, "$");
        newXSproto("Net::DBus::Binding::C::Message::dbus_message_get_signature", XS_Net__DBus__Binding__C__Message_dbus_message_get_signature, file, "$");
        newXSproto("Net::DBus::Binding::C::Message::dbus_message_set_sender", XS_Net__DBus__Binding__C__Message_dbus_message_set_sender, file, "$$");
        newXSproto("Net::DBus::Binding::C::Message::dbus_message_set_destination", XS_Net__DBus__Binding__C__Message_dbus_message_set_destination, file, "$$");
        newXSproto("Net::DBus::Binding::Message::Signal::_create", XS_Net__DBus__Binding__Message__Signal__create, file, "$$$");
        newXSproto("Net::DBus::Binding::Message::MethodCall::_create", XS_Net__DBus__Binding__Message__MethodCall__create, file, "$$$$");
        newXSproto("Net::DBus::Binding::Message::MethodReturn::_create", XS_Net__DBus__Binding__Message__MethodReturn__create, file, "$");
        newXSproto("Net::DBus::Binding::Message::Error::_create", XS_Net__DBus__Binding__Message__Error__create, file, "$$$");
        newXSproto("Net::DBus::Binding::C::PendingCall::_steal_reply", XS_Net__DBus__Binding__C__PendingCall__steal_reply, file, "$");
        newXSproto("Net::DBus::Binding::C::PendingCall::dbus_pending_call_block", XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_block, file, "$");
        newXSproto("Net::DBus::Binding::C::PendingCall::dbus_pending_call_get_completed", XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_get_completed, file, "$");
        newXSproto("Net::DBus::Binding::C::PendingCall::dbus_pending_call_cancel", XS_Net__DBus__Binding__C__PendingCall_dbus_pending_call_cancel, file, "$");
        newXSproto("Net::DBus::Binding::C::PendingCall::_set_notify", XS_Net__DBus__Binding__C__PendingCall__set_notify, file, "$$");
        newXSproto("Net::DBus::Binding::C::PendingCall::DESTROY", XS_Net__DBus__Binding__C__PendingCall_DESTROY, file, "$");
        newXSproto("Net::DBus::Binding::C::Watch::get_fileno", XS_Net__DBus__Binding__C__Watch_get_fileno, file, "$");
        newXSproto("Net::DBus::Binding::C::Watch::get_flags", XS_Net__DBus__Binding__C__Watch_get_flags, file, "$");
        newXSproto("Net::DBus::Binding::C::Watch::is_enabled", XS_Net__DBus__Binding__C__Watch_is_enabled, file, "$");
        newXSproto("Net::DBus::Binding::C::Watch::handle", XS_Net__DBus__Binding__C__Watch_handle, file, "$$");
        newXSproto("Net::DBus::Binding::C::Watch::get_data", XS_Net__DBus__Binding__C__Watch_get_data, file, "$");
        newXSproto("Net::DBus::Binding::C::Watch::set_data", XS_Net__DBus__Binding__C__Watch_set_data, file, "$$");
        newXSproto("Net::DBus::Binding::C::Timeout::get_interval", XS_Net__DBus__Binding__C__Timeout_get_interval, file, "$");
        newXSproto("Net::DBus::Binding::C::Timeout::is_enabled", XS_Net__DBus__Binding__C__Timeout_is_enabled, file, "$");
        newXSproto("Net::DBus::Binding::C::Timeout::handle", XS_Net__DBus__Binding__C__Timeout_handle, file, "$");
        newXSproto("Net::DBus::Binding::C::Timeout::get_data", XS_Net__DBus__Binding__C__Timeout_get_data, file, "$");
        newXSproto("Net::DBus::Binding::C::Timeout::set_data", XS_Net__DBus__Binding__C__Timeout_set_data, file, "$$");
        newXSproto("Net::DBus::Binding::Iterator::_recurse", XS_Net__DBus__Binding__Iterator__recurse, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::_open_container", XS_Net__DBus__Binding__Iterator__open_container, file, "$$$");
        newXSproto("Net::DBus::Binding::Iterator::_close_container", XS_Net__DBus__Binding__Iterator__close_container, file, "$$");
        newXSproto("Net::DBus::Binding::Iterator::get_arg_type", XS_Net__DBus__Binding__Iterator_get_arg_type, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::get_element_type", XS_Net__DBus__Binding__Iterator_get_element_type, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::has_next", XS_Net__DBus__Binding__Iterator_has_next, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::next", XS_Net__DBus__Binding__Iterator_next, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::get_boolean", XS_Net__DBus__Binding__Iterator_get_boolean, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::get_byte", XS_Net__DBus__Binding__Iterator_get_byte, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::get_int16", XS_Net__DBus__Binding__Iterator_get_int16, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::get_uint16", XS_Net__DBus__Binding__Iterator_get_uint16, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::get_int32", XS_Net__DBus__Binding__Iterator_get_int32, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::get_uint32", XS_Net__DBus__Binding__Iterator_get_uint32, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::_get_int64", XS_Net__DBus__Binding__Iterator__get_int64, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::_get_uint64", XS_Net__DBus__Binding__Iterator__get_uint64, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::get_double", XS_Net__DBus__Binding__Iterator_get_double, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::get_string", XS_Net__DBus__Binding__Iterator_get_string, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::get_signature", XS_Net__DBus__Binding__Iterator_get_signature, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::get_object_path", XS_Net__DBus__Binding__Iterator_get_object_path, file, "$");
        newXSproto("Net::DBus::Binding::Iterator::append_boolean", XS_Net__DBus__Binding__Iterator_append_boolean, file, "$$");
        newXSproto("Net::DBus::Binding::Iterator::append_byte", XS_Net__DBus__Binding__Iterator_append_byte, file, "$$");
        newXSproto("Net::DBus::Binding::Iterator::append_int16", XS_Net__DBus__Binding__Iterator_append_int16, file, "$$");
        newXSproto("Net::DBus::Binding::Iterator::append_uint16", XS_Net__DBus__Binding__Iterator_append_uint16, file, "$$");
        newXSproto("Net::DBus::Binding::Iterator::append_int32", XS_Net__DBus__Binding__Iterator_append_int32, file, "$$");
        newXSproto("Net::DBus::Binding::Iterator::append_uint32", XS_Net__DBus__Binding__Iterator_append_uint32, file, "$$");
        newXSproto("Net::DBus::Binding::Iterator::_append_int64", XS_Net__DBus__Binding__Iterator__append_int64, file, "$$");
        newXSproto("Net::DBus::Binding::Iterator::_append_uint64", XS_Net__DBus__Binding__Iterator__append_uint64, file, "$$");
        newXSproto("Net::DBus::Binding::Iterator::append_double", XS_Net__DBus__Binding__Iterator_append_double, file, "$$");
        newXSproto("Net::DBus::Binding::Iterator::append_string", XS_Net__DBus__Binding__Iterator_append_string, file, "$$");
        newXSproto("Net::DBus::Binding::Iterator::append_object_path", XS_Net__DBus__Binding__Iterator_append_object_path, file, "$$");
        newXSproto("Net::DBus::Binding::Iterator::append_signature", XS_Net__DBus__Binding__Iterator_append_signature, file, "$$");
        newXSproto("Net::DBus::Binding::Iterator::DESTROY", XS_Net__DBus__Binding__Iterator_DESTROY, file, "$");

    /* Initialisation Section */

#line 467 "DBus.xs"
    {
	HV *constants;

	if (getenv("NET_DBUS_DEBUG"))
	  net_dbus_debug = 1;

	/* not the 'standard' way of doing perl constants, but a lot easier to maintain */

	constants = perl_get_hv("Net::DBus::Binding::Bus::_constants", TRUE);
	REGISTER_CONSTANT(DBUS_BUS_SYSTEM, SYSTEM);
	REGISTER_CONSTANT(DBUS_BUS_SESSION, SESSION);
	REGISTER_CONSTANT(DBUS_BUS_STARTER, STARTER);

	constants = perl_get_hv("Net::DBus::Binding::Message::_constants", TRUE);
	REGISTER_CONSTANT(DBUS_TYPE_ARRAY, TYPE_ARRAY);
	REGISTER_CONSTANT(DBUS_TYPE_BOOLEAN, TYPE_BOOLEAN);
	REGISTER_CONSTANT(DBUS_TYPE_BYTE, TYPE_BYTE);
	REGISTER_CONSTANT(DBUS_TYPE_DOUBLE, TYPE_DOUBLE);
	REGISTER_CONSTANT(DBUS_TYPE_INT16, TYPE_INT16);
	REGISTER_CONSTANT(DBUS_TYPE_INT32, TYPE_INT32);
	REGISTER_CONSTANT(DBUS_TYPE_INT64, TYPE_INT64);
	REGISTER_CONSTANT(DBUS_TYPE_INVALID, TYPE_INVALID);
	REGISTER_CONSTANT(DBUS_TYPE_STRUCT, TYPE_STRUCT);
	REGISTER_CONSTANT(DBUS_TYPE_SIGNATURE, TYPE_SIGNATURE);
	REGISTER_CONSTANT(DBUS_TYPE_OBJECT_PATH, TYPE_OBJECT_PATH);
	REGISTER_CONSTANT(DBUS_TYPE_DICT_ENTRY, TYPE_DICT_ENTRY);
	REGISTER_CONSTANT(DBUS_TYPE_STRING, TYPE_STRING);
	REGISTER_CONSTANT(DBUS_TYPE_UINT16, TYPE_UINT16);
	REGISTER_CONSTANT(DBUS_TYPE_UINT32, TYPE_UINT32);
	REGISTER_CONSTANT(DBUS_TYPE_UINT64, TYPE_UINT64);
	REGISTER_CONSTANT(DBUS_TYPE_VARIANT, TYPE_VARIANT);

	REGISTER_CONSTANT(DBUS_MESSAGE_TYPE_METHOD_CALL, MESSAGE_TYPE_METHOD_CALL);
	REGISTER_CONSTANT(DBUS_MESSAGE_TYPE_METHOD_RETURN, MESSAGE_TYPE_METHOD_RETURN);
	REGISTER_CONSTANT(DBUS_MESSAGE_TYPE_ERROR, MESSAGE_TYPE_ERROR);
	REGISTER_CONSTANT(DBUS_MESSAGE_TYPE_SIGNAL, MESSAGE_TYPE_SIGNAL);
	REGISTER_CONSTANT(DBUS_MESSAGE_TYPE_INVALID, MESSAGE_TYPE_INVALID);

	constants = perl_get_hv("Net::DBus::Binding::Watch::_constants", TRUE);
	REGISTER_CONSTANT(DBUS_WATCH_READABLE, READABLE);
	REGISTER_CONSTANT(DBUS_WATCH_WRITABLE, WRITABLE);
	REGISTER_CONSTANT(DBUS_WATCH_ERROR, ERROR);
	REGISTER_CONSTANT(DBUS_WATCH_HANGUP, HANGUP);

	dbus_connection_allocate_data_slot(&connection_data_slot);
	dbus_server_allocate_data_slot(&server_data_slot);
	dbus_pending_call_allocate_data_slot(&pending_call_data_slot);
    }

#line 3636 "DBus.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

